# Infinitesimal - an Infinity-inspired OutFox theme

![logo](https://raw.githubusercontent.com/dj505/PIU-Infinitesimal/master/Graphics/logo%20(doubleres).png)

## [Discord server is now available for more development insights and discussion!](https://discord.gg/ex6e4jNm6s)

## About Infinitesimal
This theme aims to be a spiritual successor to Pump It Up Infinity, an uncommon StepMania-based spin-off developed by Team Infinity and licensed by Andamiro. The current goals are to replicate the look and feel of Infinity while sprinkling in new additions and quality of life improvements, utilize original assets when possible and bring high performance + cross-platform support to the table with OutFox.

**It is important to state that we do not condone the usage of Pay Mode or the removal of the credits on this theme. If such things are done, we will unfortunately start to block off bits of source code or give up on the project altogether.**

## Requirements
* [Project OutFox-5.3.0-alpha.4.9.10 or newer](https://projectoutfox.com/downloads)

Older StepMania versions such as `5.0.12`, `5.1b2` and `5.1-new` are not supported due to the lack of maintenance to `pump/piu` and the engine in general. Support the developers from Team OutFox who are currently doing the heavy lifting!

## Installing
Since this theme is currently on a rolling release, we highly recommend downloading the theme through GitHub Desktop (or `git` for Linux users) and pull subsequent updates that are pushed to the repository. If you're unable to do so, you can also download from the `Code > Download ZIP` button on the main page and extract the .zip file to your OutFox Themes folder (by default in `Appearance/Themes`).

**If you are upgrading from a previous version by `Download ZIP`, fully delete the old folder first. Do not merge the new folder into the old.**

## Theme Features
* USB Profiles
* Toggle between Arcade or Pro Mode to disable/enable Superbs;
* Infinity-style Command Window;
* Speed Mod options (X, C, M and A);
* Various Judgements (NJ, HJ, VJ, Infinity, PIU Pro, ITG...);
* BGA OFF + BGA Dark with adjustable levels;
* Deviation, score, measures and song progress display...;
* Customize appearance options, modifiers, rush...;
* Online(ish) multiplayer via [everyone.dance](https://everyone.dance).

![image](https://i.imgur.com/pamOyYL.png)
![image](https://i.imgur.com/2Ngk6am.png)
![image](https://i.imgur.com/OWZ69pv.png)

## Languages:
Currently, Infinitesimal supports the following languages:
* Brazilian Portuguese
* English
* Polish

## Custom Wallpapers
Infinitesimal displays randomly selected wallpapers during the profile saving screen after every song. You can add your own by dropping any wallpaper inside of the `/Graphics/Wallpapers` directory. You're free to remove the existing ones or add new ones as you like!

## Additional Resources
If you're looking for assets such as more noteskins or folder icons from StepP1, you can grab them [here](https://drive.google.com/drive/folders/1pO9rbaPUwTTDFuEo_4tX8S1BEwmfukeF?usp=sharing). Keep in mind these are independent from the theme and are only here for accessibility purposes to newcomers.

## Current Limitations and Issues
The theme currently has a few limitations that are beyond our reach. Here is a list of known limitations and issues:
* Difficulty balls are out of order due to the lack of level sorting;
* Holds might be extremely hard or easy to hit due to how the tickcount is currently handled;
* Hold heads currently counts as tap notes, you don't need to step on them but they will count in your accuracy;
* Some chart effects will be missing or broken from incomplete parsing;
* Scoring might be inconsistent due to a race condition against the engine's score.

Hopefully all of these should be gone soon with future Project OutFox developments and improvements by Team OutFox!

## Special thanks
This theme wouldn't be here if it weren't for the help of the following people:
* JoseVarelaP (loads of code optimization and refactoring, suggestions and development assistance)
* Luizsan (creator of PIU Delta / member of Team Infinity and SSC, many notes and examples taken from his work)
* Jousway (development assistance)
* Accelerator/Rhythm Lunatic (development assistance)
* Engine_Machiner (development assistance)
* Bedrock Solid (music, suggestions and playtesting)
* 4199 (suggestions and playtesting)
* SHRMP0 (suggestions and playtesting)
* Enally (suggestions and playtesting)
* djgrs (suggestions and playtesting)
* CrackItUp group (origin and home of the theme's development)
* Team Infinity (setting a landmark in PIU's interface and graphics design)
* RGAB Community

And at last, you for trying out our theme!
